#!/usr/bin/env node
const fs = require("fs");
const _path = require("path");
const creat_argv = require("nv-cli-basic");

const _pkg   = require("nv-cli-pkg");
const _nginx = require("./nginx");
const _srv   = require("./srv");
const _idx   = require("./idx");

const cfg = {
    alias: {
        'workdir'                  :     'w',
        'nginx_user'               :     'n',
        'usock'                    :     'u',
        'dbname'                   :     'd',
        'tblname'                  :     't',
        'help'                     :     'h',
    },
    description: {
        'workdir'         : 'workdir, default ./',
        'nginx_user'      : 'nginx user,default www-data',
        'usock'           : 'internal unix socket file, default ___nv_remote_user_local___',
        'dbname'          : 'database name, default wangpoapp',
        'tblname'         : 'database table name, default qrepo',
        'help':"usage",
    },
    defaults: {
        workdir:   './',
        nginx_user:'www-data',
        usock:'___nv_question_repo___',
    },
    boolean: ["help"]
}




var argv = creat_argv(cfg);
////


if(argv.h) {
    var _usage = argv.usage("nv_question_repo_cli_creat");
    console.log(_usage)
} else {
    let workdir = _path.resolve(argv.w);
    let ngx_code = _nginx.creat(argv.u,argv.w)
    console.log("=================nginx.cfg=============================\n")
    console.log(ngx_code);
    console.log("=================nginx.cfg=============================\n\n")    
    let creat_dbidx = _idx(argv.t);
    console.log("=================databse idx=============================\n")
    console.log(creat_dbidx);
    console.log("=================database idx=============================\n\n")    
    let srv_code = _srv.creat(
          argv.n,
          argv.u,
          argv.d,
          argv.t,
          argv.w
    );
    fs.writeFileSync(_path.join(workdir,"srv.js"),srv_code);
    /////////////////////////////////////////////////////////////////////////////////////
    _pkg.try_install_local_save("nv-question-repo-srv");
    //_pkg.check_cmd_and_try_install_gloal("nv-file-vfs-local-cli","nv_vfs_lcl_show -h","Options"); 
}
